Loading...
Searching...
No Matches
pcl::CropHull< PointT > Class Template Reference
Module filters

Filter points that lie inside or outside a 3D closed surface or 2D closed polygon, as generated by the ConvexHull or ConcaveHull classes. More...

`#include <pcl/filters/crop_hull.h>`

Inheritance diagram for pcl::CropHull< PointT >:

## Public Types

using | Ptr = shared_ptr<CropHull<PointT> >
using | ConstPtr = shared_ptr<const CropHull<PointT> >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| CropHull ()
| Empty Constructor.
void | setHullIndices (const std::vector< Vertices > &polygons)
| Set the vertices of the hull used to filter points.
std::vector< Vertices > | getHullIndices () const
| Get the vertices of the hull used to filter points.
void | setHullCloud (PointCloudPtr points)
| Set the point cloud that the hull indices refer to.
PointCloudPtr | getHullCloud () const
| Get the point cloud that the hull indices refer to.
void | setDim (int dim)
| Set the dimensionality of the hull to be used.
void | setCropOutside (bool crop_outside)
| Remove points outside the hull (default), or those inside the hull.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (Indices &indices) override
| Filter the input points using the 2D or 3D polygon hull.
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::CropHull< PointT >

Filter points that lie inside or outside a 3D closed surface or 2D closed polygon, as generated by the ConvexHull or ConcaveHull classes.

Author
  James Crosby

Definition at line 51 of file crop_hull.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::CropHull< PointT >::ConstPtr = shared_ptr<const CropHull<PointT> >

Definition at line 65 of file crop_hull.h.

## Ptr

template<typename PointT>

using pcl::CropHull< PointT >::Ptr = shared_ptr<CropHull<PointT> >

Definition at line 64 of file crop_hull.h.

## Constructor & Destructor Documentation

## CropHull()

template<typename PointT>

pcl::CropHull< PointT >::CropHull | ( |  | ) |

inline

Empty Constructor.

Definition at line 68 of file crop_hull.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter()

template<typename PointT>

void pcl::CropHull< PointT >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Filter the input points using the 2D or 3D polygon hull.

Parameters

  [out] | indices | the indices of the set of points that passed the filter.

Implements pcl::FilterIndices< PointT >.

Definition at line 46 of file crop_hull.hpp.

References pcl::PCLBase< PointT >::indices_, and pcl::Filter< PointT >::removed_indices_.

## getHullCloud()

template<typename PointT>

PointCloudPtr pcl::CropHull< PointT >::getHullCloud | ( |  | ) | const

inline

Get the point cloud that the hull indices refer to.

Definition at line 103 of file crop_hull.h.

## getHullIndices()

template<typename PointT>

std::vector< Vertices > pcl::CropHull< PointT >::getHullIndices | ( |  | ) | const

inline

Get the vertices of the hull used to filter points.

Definition at line 87 of file crop_hull.h.

## setCropOutside()

template<typename PointT>

void pcl::CropHull< PointT >::setCropOutside | ( | bool | crop_outside | ) |

inline

Remove points outside the hull (default), or those inside the hull.

Parameters

  [in] | crop_outside | If true, the filter will remove points outside the hull. If false, those inside will be removed.

Definition at line 125 of file crop_hull.h.

## setDim()

template<typename PointT>

void pcl::CropHull< PointT >::setDim | ( | int | dim | ) |

inline

Set the dimensionality of the hull to be used.

This should be set to correspond to the dimensionality of the convex/concave hull produced by the pcl::ConvexHull and pcl::ConcaveHull classes.

Parameters

  [in] | dim | Dimensionality of the hull used to filter points.

Definition at line 115 of file crop_hull.h.

## setHullCloud()

template<typename PointT>

void pcl::CropHull< PointT >::setHullCloud | ( | PointCloudPtr | points | ) |

inline

Set the point cloud that the hull indices refer to.

Parameters

  [in] | points | the point cloud that the hull indices refer to

Definition at line 96 of file crop_hull.h.

## setHullIndices()

template<typename PointT>

void pcl::CropHull< PointT >::setHullIndices | ( | const std::vector< Vertices > & | polygons | ) |

inline

Set the vertices of the hull used to filter points.

Parameters

  [in] | polygons | Vector of polygons (Vertices structures) forming the hull used for filtering points.

Definition at line 79 of file crop_hull.h.

The documentation for this class was generated from the following files:

- pcl/filters/crop_hull.h
- pcl/filters/impl/crop_hull.hpp